
=== 1797jumpOnTo2dot3.cs ===
Postscript:


=== 1796autoBuddy-yo-bf.cs ===
Change Set:		autoBuddy-yo-bf
Date:			22 November 2007
Author:			Bert Freudenberg

Create buddy badges when someone joins the activity

=== 1795PopUpCaretFixLayout-tak.cs ===
Change Set:		PopUpCaretFixLayout-tak
Date:			28 November 2007
Author:			Takashi Yamamiya

Fix bugs about pop up arrow's mouse hold down behavior and layout malfunction.

Trac #5126: New arrow doesn't handle mouse hold down.
Trac #5148: New arrow's strange behavior with 'forward by' and 'turn by' tile.


=== 1794DBus-Core-bf-36.cs ===
Change Set:		DBus-Core-bf-36
Date:			28 November 2007
Author:			Bert Freudenberg

Name: DBus-Core-bf.36
Author: bf
Time: 28 November 2007, 4:04:29 pm
UUID: 8973e231-73ac-4336-bdda-86a2eb81866c
Ancestors: DBus-Core-bf.35

- fix matching

=== 1793joinActivity-yo-bf.cs ===
Change Set:		joinActivity-yo-bf
Date:			22 November 2007
Author:			Yoshiki Ohshima, Bert Freudenberg

when joining, go into shared mode

=== 1792noNarrowScrollbar-sw.cs ===
Change Set:		noNarrowScrollbar-sw
Date:			21 November 2007
Author:			Scott Wallace

TRAC 3545:  Eliminate narrow scrollbars from various tools and help-flaps.

=== 1791PopUpCaretFix2-tak.cs ===
Change Set:		PopUpCaretFix2-tak
Date:			21 November 2007
Author:			Takashi Yamamiya

- Pop up carets are shown even on old project.
- Fix a bug that unnecessary up and down arrows are shown (e.g. In Ellipse's y <- Ellipse's heading, heading doesn't have up down).


=== 1790rainbowKey-bf.cs ===
Change Set:		rainbowKey-bf
Date:			21 November 2007
Author:			Bert Freudenberg

Disable sandbox and key generation if running in rainbow

=== 1789arrowTile-bf.cs ===
Change Set:		arrowTile-bf
Date:			20 November 2007
Author:			Bert Freudenberg

Make large-arrow backgrounds use tile background color

=== 1788PopUpCaretFix-tak.cs ===
Change Set:		PopUpCaretFix-tak
Date:			19 November 2007
Author:			Takashi Yamamiya

Based on Karl Ramberg's idea, position of  arrow follows width of the text.

=== 1787QG-JumpTo-tk.cs ===
Change Set:		QG-JumpTo-tk
Date:			19 November 2007
Author:			Ted Kaehler

Add ability to adjust the look of the page control in the Guides.  Method JumpToAdjust: changes colors of 'Jump to...' button and makes it act on mouseUp.

=== 1786fixPopupArrowUpDown-tak.cs ===
Change Set:		fixPopupArrowUpDown-tak
Date:			18 November 2007
Author:			Takashi Yamamiya

Mouse click event handler for vertical pop up carets did not make sense.

=== 1785logEntryOops-sw.cs ===
Change Set:		logEntryOops-sw
Date:			16 November 2007
Author:			Scott Wallace

Remove a bit of debugging printout to the transcript that crept into update 1783.

=== 1784DBus-Core-bf-35.cs ===
Change Set:		DBus-Core-bf-35
Date:			16 November 2007
Author:			Bert Freudenberg

Name: DBus-Core-bf.35
Author: bf
Time: 16 November 2007, 8:11:28 pm
UUID: c7aee0f2-7356-4442-be4d-9923c9f12f3a
Ancestors: DBus-Core-bf.34

- fix writing struct (still no containers supported though)


=== 1783fullScreenToggle-sw.cs ===
Change Set:		fullScreenToggle-sw
Date:			15 November 2007
Author:			Scott Wallace

Conform to latest sugar key bindings by mapping alt-enter into toggle-full-screen, where our interpreation of 'full-screen' is that the global flaps (sugar-nav, sugar-supplies, guides) are showing; when full-screen is off, those flaps are hidden.
Also extends this and other global cmd keys (show-source, cycle windows) to work when the kbd focus is a SimpleHierarchicalListView.

=== 1782userTextFix-kfr.cs ===
Change Set:		userTextFix-kfr
Date:			15 November 2007
Author:			Karl Ramberg

TRAC #4943 - TextMorph class-nonwrappingPrototype.

Fixes the bug that if you delete all text of a default Text object from the Supplies bin, then start typing, the new chars show up in a tiny font. 

=== 1781PopUpCaret-tak.cs ===
Change Set:		PopUpCaret-tak
Date:			14 November 2007
Author:			Takashi Yamamiya

Show pop up arrows (caret) when you mouse over a tile.


=== 1780RemoveAnOldComment-yo.cs ===
Change Set:		RemoveAnOldComment-yo
Date:			15 November 2007
Author:			Yoshiki Ohshima

Clean up a left over obsoleted comment.

=== 1779classicNaviTrans-KR.cs ===
Change Set:		classicNaviTrans-KR
Date:			14 November 2007
Author:			Korakurider

translate buttons of classic etoys navigator, NebraskaNavigator, and InternalThreadNavigator

=== 1778Paint-World-tk.cs ===
Change Set:		Paint-World-tk
Date:			14 November 2007
Author:			Ted Kaehler

When painting the World background, if you erase the picture, and then keep, there is a divide-by-zero error.

When painting the background, keep the result in the same place on the screen.  Do not center it.

Fix odd bug in computing the depth from the top of a project that is a DIskProxy.

=== 1777FileDialogToCatalog-yo.cs ===
Change Set:		AddFileDialogToCatalog-yo
Date:			14 November 2007
Author:			Yoshiki Ohshima

Even on XO, there should be a way to access the files on the file system.

=== 1776authorName-bf.cs ===
Change Set:		authorName-bf
Date:			12 November 2007
Author:			Bert Freudenberg

Set authorName to the XO owner's name on startup.

=== 1775balloonHelpLocation-yo.cs ===
Change Set:		balloonHelpLocation-yo
Date:			13 November 2007
Author:			Yoshiki Ohshima

Now you can force the direction of balloon help to particular direction.

=== 1774TextFieldFocus-yo.cs ===
Change Set:		TextFieldFocus-yo
Date:			13 November 2007
Author:			Yoshiki Ohshima

The text object in the rounded field should be easier to type in.

=== 1773DynCheckSecurity-yo.cs ===
Change Set:		DynCheckSecurity-yo
Date:			13 November 2007
Author:			Yoshiki Ohshima

Revert the default setting for security check (for non-XO environments) but dynamically check the running environment and disable it.

=== 1772noKomika-sw.cs ===
Change Set:		noKomika-sw
Date:			9 November 2007
Author:			Scott Wallace

Eliminate remaining uses of Komika font in the etoys UI.
Adds an eToyTitleFont item to the font-configuration menu.
Makes the font-configuration menu be an UpdatingMenuMorph.

=== 1771DisableSandbox-yo.cs ===
Change Set:		DisableSandbox-yo
Date:			9 November 2007
Author:			Yoshiki Ohshima

On Sugar, we rely on the Rainbow security system.

Squeak's sandboxing trys to restrict the access to one directory, but Rainbow requires three directories to be accessed for a proper activity.  As long as Rainbow prevents a malicious project running on top of Etoys to access other files, we don't have to restrict ourselves.

=== 1770SISSProxy2-yo.cs ===
Change Set:		SISSProxy2-yo
Date:			8 November 2007
Author:			Yoshiki Ohshima

Add a little check so that it doesn't execute arbitrary method.

=== 1769SISSProxy-yo.cs ===
Change Set:		SISSProxy-yo
Date:			8 November 2007
Author:			Yoshiki Ohshima

Enable a way to store some objects that are not reachable from the root object.

=== 1768AllowReadonlyChanges-yo.cs ===
Change Set:		AllowReadonlyChanges-yo
Date:			8 November 2007
Author:			Yoshiki Ohshima

For the view source feature, this change set supports readonly .changes file more gracefully.

=== 1767RenameLauncher-yo.cs ===
Change Set:		RenameLauncher-yo
Date:			7 November 2007
Author:			Yoshiki Ohshima

Rename the Launcher project to Etoys Activity.

=== 1766SugarNav20-yo.cs ===
Change Set:		SugarNav20-yo
Date:			7 November 2007
Author:			Yoshiki Ohshima

The project name field tracks the screen size change.  Also, it has a balloon help now.

=== 1765BiggerPaintBox2-yo.cs ===
Change Set:		BiggerPaintBox2-yo
Date:			7 November 2007
Author:			Yoshiki Ohshima

Add a preference to control the painting box size.

=== 1764BigPaintBox-ka.cs ===
Change Set:		BigPaintBox-ka
Date:			31 October 2007
Author:			Kazuhiro Abe

This patch makes a PaintBox big. (1.5X)

=== 1763suppliesFlapFixes-sw.cs ===
Change Set:		suppliesFlapFixes-sw
Date:			7 November 2007
Author:			Scott Wallace

Fix the all-scripts-tool token in the supplies flap.
Restore book-morph to supplies flap.
Remove triangle from supplies flap.

=== 1762showSourceAgain-sw.cs ===
Change Set:		showSourceAgain-sw
Date:			6 November 2007
Author:			Scott Wallace

Pop up the show-source menu on ctrl-comma as well as on alt-comma, trying to contend with both settings of the swapControlAndAltKeys pref.

=== 1761userTextObject-sw.cs ===
Change Set:		userTextObject-sw
Date:			7 November 2007
Author:			Scott Wallace

Provide, in the Supplies flap and the Objects tool, and as the base class for pasted text, a default text object that:
- grows/shrinks horizontally as the user types/erases.
- switches to 'wrap' mode if the user manually resizes.
- switches to 'wrap' mode if the edge of the container is reached.
Add the notion of a #translatable property for TextMorphs; User-Text objects obtained from Supplies, etc., have it.  When any TextMorph has such a property, then when locale changes it gets its localeChanged method triggered.  The property can be set interactively from a new checkbox in the text-morphs halo menu.  Also extends the be-all-font menu item from Connectors to generic TextMorph.

=== 1760SugarNav19-yo.cs ===
Change Set:		SugarNav19-yo
Date:			6 November 2007
Author:			Yoshiki Ohshima

Make the rounded field wider when there is enough space.

It still doesn't track extent changes and color change, that is a to-do for later version.

=== 1759keyLoc-bf.cs ===
Change Set:		keyLoc-bf
Date:			6 November 2007
Author:			Bert Freudenberg

Look for owner.key in the right directory.

=== 1758screenshot-bf.cs ===
Change Set:		screenshot-bf
Date:			6 November 2007
Author:			Bert Freudenberg

Handle DBus TakeScreenshot() method (by explicitely doing nothing which avoids a Sugar error).

=== 1757properShare-bf.cs ===
Change Set:		sharing-bf
Date:			14 October 2007
Author:			Bert Freudenberg

Integrate with presence service: Etoys instances will be visible in the mesh when shared, and must be joined by clicking the icon in the mesh view.

=== 1756newBookRevert-yo.cs ===
Change Set:		newBookRevert-yo
Date:			5 November 2007
Author:			Yoshiki Ohshima

Provides better revert for book pages.

In the previous implementation, the revert data was saved along with the book.  However, in the typical use, you almost always want to go back to the last saved state; this means that you only save one good version and defer the creation of   revert data after the project is loaded.

=== 1755TryHardToCleanup-yo.cs ===
Change Set:		TryHardToCleanup-yo
Date:			5 November 2007
Author:			Yoshiki Ohshima

In the World's references dictionary, a deletion can open the door for more deletion.  It should loop untill it reaches a stable point.

=== 1754Paint-place-tk.cs ===
Change Set:		Paint-place-tk
Date:			5 November 2007
Author:			Ted Kaehler

Fix silly error that made repaint come up in the wrong place on the screen.

=== 1753roundInput-bf.cs ===
Change Set:		roundInput-bf
Date:			5 November 2007
Author:			Bert Freudenberg

Fix text quality by not drawing the label twice, and anti-alias the ends.

=== 1752QuickGuide-order-tk.cs ===
Change Set:		QuickGuide-order-tk
Date:			2 November 2007
Author:			Ted Kaehler

Change the order of guides in the menus in the index.

To see the new order, close help (click ? icon) and open Help again.

(The OLPC build will have the new order.)

=== 1751QuickGuides5-tk.cs ===
Change Set:		QuickGuides5-tk
Date:			2 November 2007
Author:			Ted Kaehler

This changeSet creates QuickGuides index at build time.

Image no longer holds the index as a mime string.  IndexPageMimeString is an empty string.  IndexPage hangs onto the Index when it is not showing.

Bert:  You must have file preload-index.sexp.data.gz in QuickGuides.  File index.pr should not be present, and it will be deleted by my code.  
	Please exclude file 'preload-index.sexp.data.gz' from QuickGuides in the RPM.  Once it is read into the image it is not needed.

=== 1750HandleResize-kfr-yo.cs ===
Change Set:		HandleResize-kfr-yo
Date:			2 November 2007
Author:			Karl Ramberg and Yoshiki Ohshima

Adjust the handle size of Jerome's StarMorph and others.

=== 1749StarMorph-wiz.cs ===
Change Set:		StarMorph-wiz
Date:			11 December 2004
Author:			wiz (Jerome Peace)

with:
Change Set:		StarMorphPlus-wiz
Date:			4 January 2005
Author:			wiz (Jerome Peace)

wiz 1/11/2005 21:44

Added insureCompatibility when adding handles.

wiz 1/11/2005 20:52

Fixed menu bug with twinkle actions.

wiz 1/11/2005 19:52

Modularized generation and separated the handling of  handle groups.
Updated Class comment. And handle balloon comments.

wiz 1/11/2005 15:09
Another good stopping point. Added wrapping forms of prev/next. Modularized menu items for more/less prev/next. And made prev/next handles twinkle or not depending on the shift key.

wiz 1/11/2005 13:46
The skipRatios are now producing the correct ratios. So this is a good save point.
ToDo: 
Get next and previous handles to twinkle i.e. wrap. 
Give option of having 2, 4 or 6 handles up at a time. Outer/inner  more/less next/prev.
And fix up handle code to be more modular.

Here are the additions to StarMorph-wiz to add the ability to adjust the stars shape.  The theory is you should be able to get an accurate depiction of the skip stars this way.  In practice, the starRatios don't seem to be accurate and too many round off errs seem to creep in with the floating point arithmetic.
Still if I can find some accurate way of forming skip ratios its all done.

wiz 12/30/2004 03:07
Extreme testing showed a bug at 360 sides. Corrected by adding precision to constant. Bug will show up at 360000 sides or there abouts.
wiz 12/29/2004 00:27
Fixed spelling error in class comment. This is saved in 3.2 since I wanted to save a play-with-me backwardly compatible this far.
Play with me loads in 3.8 (I checked). I presume it will load in everything before that.  It also loads in  3.9 (with deprection error because of the system window for the workspace holding the text.

wiz 12/19/2004 00:50
Hopefully the final changes have now been made. I found that to make my claims of backward compatability true I needed to fix one more bug. The vertices must be checked to insure the first vertex is a point not a valley. That done the adding the new handles to the old already formed stars works fine.

wiz 12/15/2004 01:20
Fixed a hardly noticable bug that caused odd sided gons to look odd just after being changed. Now they will always look regular. And added  handles to adjust the number of points and sides. Also mucked with their look. I'm rather pleased with the end result.

This is an Enhancement for StarMorph.
The enhancements do not change the old behavior of the StarMorph (except for the outer handle bug fix). 

The enhancements add some useful behavior that allows the StarMorph to generate stars with any number of points; control the pointyness of those stars; and generate any of the regular polygons. 

1) The outer handle now stays where you put it.
2) Shift draging the outer handle now changes the pointiness of the star.
3) Custom menu items have been added to change the number of points. 
4) Class comment has been added to explain features and changes.



=== 1748narrowCursor2-tak.cs ===
Change Set:		narrowCursor2-tak
Date:			2 November 2007
Author:			Takashi Yamamiya

Fixed transparent color of the cursor to use alpha pre-multiplied.
https://dev.laptop.org/ticket/2813.


=== 1747narrowCursor-tak.cs ===
Change Set:		narrowCursor-tak
Date:			2 November 2007
Author:			Takashi Yamamiya

Use Bluecurve large cursor.

=== 1746showSource-sw.cs ===
Change Set:		showSource-sw
Date:			1 November 2007
Author:			Scott Wallace

React to the hitting of the show-source key on the xo by putting up a show-source menu allowing access to the inner Squeak world...

=== 1745PreventGoingTopProj-yo.cs ===
Change Set:		PreventGoingTopProj-yo
Date:			1 November 2007
Author:			Yoshiki Ohshima

On XO, you don't want to exit to the top-level project, as there is no way to come back.

=== 1744SoundMixer-yo.cs ===

=== 1743noHelpDragover-sw.cs ===
Change Set:		helpStayOpen-sw
Date:			1 Nov 2007
Author:			Scott Wallace

Make the help flap *not* close when things are dragged out from it.

=== 1742SugarNav18-yo.cs ===
Change Set:		SugarNav18-yo
Date:			31 October 2007
Author:			Yoshiki Ohshima

Even on a non-XO environment, it adds the project name text field.

=== 1741SugarNav17-yo.cs ===
Change Set:		SugarNav17-yo
Date:			31 October 2007
Author:			Yoshiki Ohshima

Add project name field and also make the share button intelligent. 

=== 1740TransCategory-KR.cs ===
Change Set:		TransCategory-KR
Date:			28 October 2007
Author:			Korakurider

To make sure all of viewer category symbols are exported to POs/POT and translated

=== 1739SymListWOCamel-KR.cs ===
Change Set:		SymListWOCamel-KR
Date:			30 October 2007
Author:			Korakurider

SymbolListTile show options and readout as no camel case. 
The no-camel words will be used for translation key.


=== 1738transSymbols2-tak.cs ===
Change Set:		transSymbols2-tak
Date:			31 October 2007
Author:			Korakurider, Takashi Yamamiya

to make sure that all of symbols  in vocabulary will be exported to POs and will be translated.
Takashi Yamamiya modified it in stupid but simple way.


=== 1737fastChooseLang-KR.cs ===
Change Set:		fastChooseLang-KR
Date:			30 October 2007
Author:			Korakurider

to avoid loading of MOs for all locales on #chooseNaturalLanguage.
By this, language selection menu will show up in reasonable speed

=== 1736NewClipboard2-yo.cs ===
Change Set:		NewClipboard2-yo
Date:			29 October 2007
Author:			Yoshiki Ohshima

A fix for the previous change.

=== 1735NewClipboard-yo.cs ===
Change Set:		NewClipboard-yo
Date:			29 October 2007
Author:			Yoshiki Ohshima

Make simple text clipboard work on newer and older VMs.SqueakDebug

=== 1734ConsistentFileName-yo.cs ===
Change Set:		ConsistentFileName-yo
Date:			29 October 2007
Author:			Yoshiki Ohshima

Set the name instance variable with proper value.

The stream created by requestDropStream: does not have to have proper file name, but just for the sake of consistency.

=== 1733translucFix-sw.cs ===
Change Set:		translucFix-sw
Date:			29 October 2007
Author:			Scott Wallace

TRAC #4512 - Fix bug that broke setting of translucency in all four translucency sliders of the full Object Properties Morph.

=== 1732removePipe-bf.cs ===
Change Set:		removePipe-bf
Date:			29 October 2007
Author:			Bert Freudenberg

Remove old pipe protocol from when we still used the Python wrapper.

=== 1731UpdBtnFontFix-KR.cs ===
Change Set:		UpdBtnFontFix-KR
Date:			19 October 2007
Author:			Korakurider

FIX for TRAC 4150: when change language, font for ticking button in scriptor is lost


=== 1730transDom3-tak.cs ===
Change Set:		transDom3-tak
Date:			25 October 2007
Author:			Takashi Yamamiya

TextDomainManager >> domainForClass: receives a class instead of class name as its argument var name.


=== 1729transDom2-KR.cs ===
Change Set:		TransDom2-KR
Date:			25 October 2007
Author:			Korakurider

TextDomainManager now holds also class->domain mappings.
#translated try to resolve domain by class, not class category.


=== 1728transDom1-KR.cs ===
Change Set:		transDom1-KR
Date:			23 October 2007
Author:			Korakurider

+ Refine registration API for classCategory->domain mapping.  Addon application can register its domain by prefix (i.e. package name) with #registerCategoryPrefix:domain:  
+ Responding to domain (un)registration event, MO is dynamically (un)loaded.
+ #translated decide text domain by sender 


=== 1727cleanupMOSupport3-tak.cs ===
Change Set:		cleanupMOSupport3-tak
Date:			24 October 2007
Author:			Takashi Yamamiya

Keep backward compatibility.

I happened to break backward compatibility about GetTextImporter, sorry.
Because .mo overrides the internal translation dictionary,
still you can't see translation without remove lang/ (You might think this is still a bug though...).
But DrGeoII.sar can be loaded anyway.


=== 1726SystemFont2-yo.cs ===
Change Set:		SystemFont2-yo
Date:			22 October 2007
Author:			Yoshiki Ohshima

Change the system font upon release builder.

=== 1725SystemFont-yo.cs ===
Change Set:		systemFont-yo
Date:			22 October 2007
Author:			Yoshiki Ohshima

Fix the recursive fallbackfont problem.

=== 1724soundLibrary-kfr-sw.cs ===
Change Set:		soundLibrary-kfr-sw
Date:			20 October 2007
Author:			Karl Ramberg, Scott Wallace

A tool for browsing and managing the sound library.  Consult class comment of SoundLibraryTool for details..

=== 1723anonymousSound-sw.cs ===
Change Set:		anonymousSound-sw
Date:			20 October 2007
Author:			Scott Wallace, Karl Ramberg

Handle a drop of an external sound file by opening an AnonymousSoundMorph, allowing the user to play the sound, drop it into a piano roll or an event roll, and also offering the option to add the sound to the sound library.

The AnonymousSoundMorphs obtained from the 'hand me a sound token' menu item in the Sound Recorder's menu are now also of the same expanded sort, which is to say, they show a prospective name for the sound, and provide controls to play, stop, and save. 

When deployed inside a PianoRoll, AnonymousSoundMorphs slim down to dimensions and proportions appropriate for the Piano Roll.  When/if returned to the desktop, they flesh out to their full form with button controls.

=== 1722kbdMorphForInput-kfr.cs ===
Change Set:		kbdMorphForInput-kfr
Date:			21 October 2007
Author:			Karl Ramberg, tweaked by Scott Wallace

Use the bigger font for the buttons on the KeyboardMorphForInput, and fix the bug that stopAllSounds, sent to such a keyboard, would generate an error.

=== 1721waveAndGraphFixes-kfr.cs ===
Change Set:		waveAndGraphFixes-kfr
Date:			18 October 2007
Author:			Karl Ramberg

Use olpc fonts in the WaveEditor.
Also, properly hook up the 'play' etoy command to the 'play' function of the GraphMorh.

=== 1720support-sw.cs ===
Change Set:		support-sw
Date:			20 October 2007
Author:			Scott Wallace

Four little changes:
* Morph class >> newInHand, (ported from Moshi).
* PianoKeyboardMorph >> soundPlayingListAt: bulletproofed against index out of range.
* ScriptingTileHolder - refrains from locking its contents if contents consist only of a simple sound-constant tile.
* Adds accessor method for ExternalDropHandler>action, helpful in debugging.

=== 1719cleanupMOSupport2-tak.cs ===
Change Set:		cleanupMOSupport2-tak
Date:			19 October 2007
Author:			Takashi Yamamiya

- Rename NaturalLanguageTranslator2 to NaturalLanguageTranslator.
- InternalTranslator becames a subclass of NaturalLanguageTranslator.
- Cleanup startup process of NaturalLanguageTranslator.


=== 1718cleanupMOSupport1-tak.cs ===
Change Set:		cleanupMOSupport1-tak
Date:			19 October 2007
Author:			Takashi Yamamiya

The first path to cleanup NaturalLanguageTranslator structure.

- remove NaturalLanguageTranslatorWrapper.
- rename NaturalLanguageTranslator to InternalTranslator.
- remove an inst var named 'id' in InternalTranslator.
- rename a class var named 'CachedTranslators' to 'Translators'.


=== 1717switchGetTextRT-KR.cs ===
Change Set:		switchGetTextRT-KR
Date:			17 October 2007
Author:			Korakurider

make EToys to use new translation stuff.
Note that GetTextExporter2/Importer and LanguageEditor continue using legacy transation stuff
 even after this patch applied

=== 1716gettextRT1-KR.cs ===
Change Set:		gettextRT1-KR
Date:			17 October 2007
Author:			Korakurider

NaturalLanguageTranslator2 is new language translation framework 
introducing the concept of translation domain (i.e. textdomain of gettext).   
While this is intended to replace the legacy NaturalLanguageTranslator,
interim NaturalLanguageTranslatorWrapper is provided for migration.
GetTextTranslator is emulation stuff of gettext runtime.


=== 1715utf8toSqueakFix2-yo.cs ===
Change Set:		utf8toSqueakFix2-yo
Date:			17 October 2007
Author:			Yoshiki Ohshima

Revert the change for now.  For clipboard and others, it will need a wrapper for this.

=== 1714UnicodeInput2-yo.cs ===
Change Set:		UnicodeInput2-yo
Date:			17 October 2007
Author:			Yoshiki Ohshima

Fix the way it checks the VM version.

=== 1713UnicodeInput1-yo.cs ===
Change Set:		UnicodeInput1-yo
Date:			16 October 2007
Author:			Yoshiki Ohshima

First attempt to enable Unicode composed characters.

=== 1712utf8toSqueakFix-yo.cs ===
Change Set:		utf8toSqueakFix-yo
Date:			16 October 2007
Author:			Yoshiki Ohshima

For obscure languages the character created should bear proper language tag.

=== 1711UTF8Clipboard.cs ===
Change Set:		UTF8Clipboard
Date:			4 June 2007
Author:			Andreas Raab

- UTF8 clipboard support

=== 1710ctrlAlt-bf.cs ===
Change Set:		ctrlAlt-bf
Date:			16 October 2007
Author:			Bert Freudenberg

Keep swapControlAndAltKeys from mangling non-letters

=== 1709playfieldOpt-sw.cs ===
Change Set:		playfieldOpt-sw
Date:			15 October 2007
Author:			Scott Wallace

Another detail w.r.t. 1703playfieldOptionsCat:  don't offer an empty playfield options cateogry in the world's viewer, which still was happening in non-etoy-friendly mode.>

=== 1708pageTurnViewer.cs ===
Change Set:		deleteViewersOnPageTurn-sw
Date:			15 October 2007
Author:			Scott Wallace

Remove any viewers from the screen that relate to objects that go away because of the page-turn of a book. (TRAC 3618: Viewers should close upon page change in Quick Guides.)

=== 1707noNilInit-sw.cs ===
Change Set:		noNilInit-sw
Date:			15 October 2007
Author:			Scott Wallace

Remove UndefinedObject>>initialize, totally spurious code that somehow snuck into the customevents package a few years ago.

=== 1706noWorldTransluc-sw.cs ===
Change Set:		noWorldTransluc-sw
Date:			15 October 2007
Author:			Scott Wallace

Do not accept translucency in the setting of the World's color, nor of its 'second color' if a gradient-fill is in effect.

=== 1705removeLenna-yo.cs ===
Change Set:		removeLenna-yo
Date:			15 October 2007
Author:			Yoshiki Ohshima

Remove a big literal.

It had a picture of  nice looking woman famous in the CG field.  If you still see the picture go to Internet and not look at an educational environment for kids.

=== 1704QuickIndex4-tk.cs ===
Change Set:		QuickIndex4-tk
Date:			15 October 2007
Author:			Ted Kaehler

In Guide file names, allow a dash (-) to mean a space,  To get title of a guide to be 'Viewer of Tiles', make the file name be Viewer-ofTiles.  The dash will make a space before the 'of'.

When the index is loaded, the Guide is not a blank green playfield anymore.

Fixed bug where several indexes were not deleted and were piling up in QuickGuideHolderMorph.

Compressed index file (index.sexp.data.gz) is now allowed in the QuickGuides folder.


=== 1703playfieldOptionsCat-sw.cs ===
Change Set:		playfieldOptionsCat-sw
Date:			14 October 2007
Author:			Scott Wallace

Disenfranchise the playfield-options item in pasteUpMorph's viewer.

=== 1702gettextExpCtx-KR.cs ===
Change Set:		gettextExpCtx-KR
Date:			12 October 2007
Author:			Korakurider

On extracting phrases from method that name is like additionsToViewerCategoryXXX,
method names are shown wrongly as #additionToViewerCategory in context comment of POs.
Now the correct context will been shown in POs by this patch.

=== 1701ObjToolLocChg-KR.cs ===
Change Set:		ObjToolLocChg-KR
Date:			10 October 2007
Author:			Korakurider

Now openning object catalogue can respond to locale change
and update page for new locale with trying to keep current mode.
(trac#3743)


=== 1700QuickIndex3-tk.cs ===
Change Set:		QuickIndex3-tk
Date:			12 October 2007
Author:			Ted Kaehler

Changed the way names of guides are displayed:
	Top of Guide:  You are allowed to put whatever you want here.  What you have been doing is great:  Category name, colon, a detailed name of this topic.  It may be longer than the title at the bottom.
	Name at bottom between the prev and next arrows:   This will automatically be determined by the .pr name.  My program will take the .pr name, remove the category, and put spaces between the words.  All you have to do is set the .pr file name.  (I will remove any digits after the name.  I will remove the version .005 also)
	Name in the Jump To list:  This will be identical to the name at the bottom (that is, when that guide is showing).  The same as I generate from the .pr file name.

So, all you have to do is adjust .pr file name.  Only change the part between the Category name (Books) and the dot.

Also sped up menu generation.  It now searches the pages, not the directory on the disk.  To force it to look at the files on the disk, close help and open again by pressing help button in Sugar bar.

Jump To menu is now displayed in the Guide, not off the bottom of the guide.


=== 1699worldRecolorHalo-sw.cs ===
Change Set:		worldRecolorHalo-sw
Date:			10 October 2007
Author:			Scott Wallace

Make the recolor handle available in the world halo.
Make the extended property-sheet for the world *not* offer irrelevant and dangerous border-width and drop-shadow items.

=== 1698setAsBackgroundFix-sw.cs ===
Change Set:		setAsBackgroundFix-sw
Date:			10 October 2007
Author:			Scott Wallace

Fix for TRAC #3888  -- 'After setting the image made from painting as background, Etoys can not work properly'.

(This bug, it turns out, has been there forever.  I'd never used this feature, nor even really been aware of it until now.)

The symptom of the bug is that screen refresh goes haywire -- portions of screen areas damaged, for example, by balloon help or by pop-up menus, were never getting refreshed, even after a 'restore display'.

The bug is caused by allowing the InfiniteForm used as the desktop background to have areas of transparency.  The morphic refresh logic assumes that the drawing of the world's color will completely erase  the screen, but that doesn't happen if the world's color has any translucency, because damaged areas under translucent bits are in fact not cleared, thus leading to the bizarre display phenomena mentioned in the TRAC report.

The same phenomenon can be generated by making the world's color be not an InfiniteForm but rather a simple color with any translucency -- the areas behind menus and help balloons will not get refreshed, etc.  This would seem to imply that  only non-transulcent colors are acceptable as desktop colors... so that's still something that needs to be dealt with.

=== 1697gridVisFix-sw.cs ===
Change Set:		gridVisFix-sw
Date:			10 October 2007
Author:			Scott Wallace

Corrects a typo in etoys2.2 update 1669playfieldOptions-sw that broke the action of the toggle in the playfield options menu which governs whether the grid should be visible.

=== 1696gradientWorld-sw.cs ===
Change Set:		gradientWorld-sw
Date:			10 October 2007
Author:			Scott Wallace

Make relevant items in the fill & border category be visible in the World' sviewer.

=== 1695unBatchPenTrails-yo.cs ===
Change Set:		unBatchPenTrails-yo
Date:			10 October 2007
Author:			Yoshiki Ohshima

Turn off batch pen trails option.

=== 1694QuickIndex2-tk.cs ===
Change Set:		QuickIndex2-tk
Date:			9 October 2007
Author:			Ted Kaehler

Allow the index to be read as a .pr file in QuickGuides.  The new index MUST be named 'index.pr'  with no version number.

Wrote code to allow the buttons in the index page to bring up a short menu of the guides in that category.  Will not be used until there is an Index project that knows to call it.

QuickGuideGenerator puts new files in a folder called Newest, not in the QuickGuides folder.  


=== 1693FileOpenFixes.cs ===
Change Set:		FileOpenFixes
Date:			27 September 2007
Author:			kks

Media files are now opened in readonly mode instead of read/write for playing

=== 1692ProjectQueryMorphFix-mu.cs ===
Change Set:		EToyProjectQueryMorphFix-mu
Date:			28 September 2007
Author:			Masashi Umezawa

Fix to send encoded query string to SuperSwiki server. It enables searching e-Toy projects by MultiString queries.

=== 1691noCamels-bf.cs ===
Change Set:		noCamels-bf
Date:			8 October 2007
Author:			Bert Freudenberg

Consistently use space instead of capitalization to separate words in tiles. Also export space-separated words into gettext templates, reusing existing translations.

ATTENTION: Changeset has been rearranged manually

=== 1690underlineCommentGT-tak.cs ===
Change Set:		underlineCommentGT-tak
Date:			6 October 2007
Author:			Takashi Yamamiya

It replaces all white spaces to _ in gettext comments.
Because gettext tools might replace a space to a new line sometimes, and it makes difficult to take a diff.

=== 1689bookMenu-sw.cs ===
Change Set:		bookMenu-sw
Date:			4 October 2007
Author:			Scott Wallace

Makes the 'book' menu obtained from the halo-menu be the same animal obtained by clicking on the menu-icon in the book's control panel.
Adds 'find-again' alongside 'find' in the menu for much greater convenience doing repeated text searches.
Provides balloon help for book menu items.
Provides #translated/translatedNoop calls as appropriate in the book menu.

=== 1688addTranslatedList-sw.cs ===
Change Set:		addTranslatedList-sw
Date:			4 October 2007
Author:			Scott Wallace

Append #translatedNoop calls to literal arguments provided to #addTranslatedList: calls in a host of places.

=== 1687scorePlayer-kfr.cs ===
Change Set:		scorePlayer-kfr
Date:			19 September 2007
Author:			Karl Ramberg

Use latest etoy fonts in Score Player.

Integrated into olpc image, with some layout fixups, 4 October 2007, Scott Wallace.

=== 1686polygonMenu-sw.cs ===
Change Set:		polygonMenu-sw
Date:			17 August 2007
Author:			Scott Wallace

Cleanup of the custom portion of the halo menu of a PolygonMorph.

=== 1685QuickGIndex-tk.cs ===
Change Set:		QuickGIndex-tk
Date:			4 October 2007
Author:			Ted Kaehler

1) Add 'Index' to the Jump to Guide menu, so one can get back to the Index page.

2) Allow .pr files in the QuickGuides folder (for debugging).  You can drop a .pr file for a Guide into the QuickGuide folder on your disk, and the .pr for that guide (with the highest number) will load instead of the .sexp.data.gz file.  This is only intended for testing in our group.  It lets you drag a guide from Kathleen's folder on the server to your disk and try it.  (This may leave garbage players in your image.)

3) Redid the bar at the bottom of the Guide to be (1/4  <-  Name of Guide  ->  Jump to...).  The 'Jump To' menu is the way to get to another Guide at any time.

=== 1684sortedPObyCategory-tak.cs ===
Change Set:		sortedPObyCategory-tak
Date:			3 October 2007
Author:			Takashi Yamamiya

Sort PO file entries by class categories -> class -> methods -> msgid (alphabetical)


=== 1683worldHaloMenu-sw.cs ===
Change Set:		worldHaloMenu-sw
Date:			3 October 2007
Author:			Scott Wallace

Harmonize and rationalize the eToyFriendly and non-eToyFriendly versions of the world halo menu.
Remove 'layout' from both versions.
Some rewording, reordering, refactoring.



=== 1682distanceAndBearing-sw.cs ===
Change Set:		distanceAndBearing-sw
Date:			3 October 2007
Author:			Scott Wallace

Finally adds the long-expected numeric-valued slots, each with a player-valued argument, to,the viewer, to assist in simulations:  distanceTo: and, bearingTo:.  These would be very happy to support watchers and readouts-in-viewers, but that will need to wait for another time.

=== 1681sortedPOFile-tak.cs ===
Change Set:		sortedPOFile-tak
Date:			2 October 2007
Author:			Takashi Yamamiya

#3596 Sorting in pot files
A small fix for GetTextNormCR-KR, and unit test for GTExpByDomain-KR is included.


=== 1680GTExpByDomain-KR.cs ===
Change Set:		GTExpByDomain-KR
Date:			2 October 2007
Author:			Korakurider

Now GetTextExporter2 exports POs based on textdomain for class category

=== 1679graphPaperPickers-sw.cs ===
Change Set:		graphPaperPickers-sw
Date:			1 October 2007
Author:			Scott Wallace

TRAC 2870:  	Use appropriate color pickers for constructing graph paper, and position them appropriately

=== 1678embedDynamic-sw.cs ===
Change Set:		embedDynamic-sw
Date:			1 October 2007
Author:			Scott Wallace

Make the 'embed' command compute its potential targets dynamically, rather than in a static submenu which is quickly obsoleted if the menu is pinned up and then things are moved around.  Use an updating-menu-item, so that when embedding is irrelevant, the item is grayed out, rather than offering the lone baffling choice 'world', and so that the list of potential targets is correct up to the moment rather than reflecting the state of affairs at the time the halo menu was first put up.

The embed feature is still far from user-friendly, since the list of possible targets is still computed based on a core sample directly beneath the morph's (reference) position point, as it has been from the very beginning of Morphic.  I'm sure this is also very baffling to users, and really ought to be reinvented.

With this update, a number of tweaks attempt to improve the experience, in any case.  When the embed menu is put up, the menu title is more helpful, and the choice of depositing the object on the 'desktop' now is represented by 'desktop' rather than by the enigmatic 'world', and the object's current container is highlighted in red so the user will easily be able to discern which choice will be a no-op.  Finally, there is bulletproofing now in place against the unusual but not unknown situation in which an attempt is made to embed an object in one of its own sub (or sub-sub) morphs, which fomerly led to infinite recursion.

This update also trims out several more items from the universal red halo menu in the eToyFriendly case:
	- no layout menu
	- no stacks and cards.

Also, a fix to UpdatingMenuMorph which assurse that the icons in the menu title bar are correct, and a fix to UpdatingMenuItemMorph that allows enablement to work even if there is no wording selector are finally now brought into the mainstream image; these fixes been present in the Vancouver, TinLizzie, and Moshi lines for four years...

=== 1677evtTheatreNav-sw.cs ===
Change Set:		evtTheatreNav-sw
Date:			1 October 2007
Author:			Scott Wallace

Brings the pseudo-sugar nav bar in the event theatre back more closely into line with current sugar-nav-bar theory, by putting the toybox icon between the paint-palette and the undo icon.

=== 1676playbackCursorPos-sw.cs ===
Change Set:		playbackCursorPos-sw
Date:			1 October 2007
Author:			Scott Wallace

Fixes the initial positioning of the playback cursor in event-theatre and event-playback-space.

=== 1675pasteUpHalo-bf.cs ===
Change Set:		pasteUpHalo-bf
Date:			1 October 2007
Author:			Bert Freudenberg

Respect #wantsHaloFromClick property in  PasteUpMorphs

=== 1674GuideInPrs-tk.cs ===
Change Set:		GuideInPrs-tk
Date:			28 September 2007
Author:			Ted Kaehler

The QuickGuideGenerator converts files from .pr to Yoshiki's new format.  
This update makes the converter larger, so the file list works better.  

QuickGuideGenerator new openInWorld.

Select the folder with the .pr files.  Press Generate.

=== 1673GetTextNormCR-KR.cs ===
Change Set:		GetTextNormCR-KR
Date:			26 September 2007
Author:			Korakurider

adjust msgstr to work around strict format checking by msgfmt tool :
   - append first(last) cr to msgstr if msgid starts(ends) with cr
   - split first(last) cr from msgstr if msgid starts(ends) without cr


=== 1672fixArrayTransNoop-tak.cs ===
Change Set:		fixArrayTransNoop-tak
Date:			27 September 2007
Author:			Takashi Yamamiya

- fix and add a test case for ArrayTransNoop-KR

I found ArrayTransNoop ignores symbol as a receiver of #translated.
(There are cases in #likelyCategoryToShow)
But I don't think it is nessesary, so I ignored it.


=== 1671fixNoErrorSUnit-tak.cs ===
Change Set:		fixNoErrorSUnit-tak
Date:			27 September 2007
Author:			Takashi Yamamiya

SUnit misunderstood Object>>test:ifTrue:ifFalse: was a test case.

=== 1670ArrayTransNoop-KR.cs ===
Change Set:		ArrayTransNoop-KR
Date:			27 September 2007
Author:			Bert Freudenberg, Korakurider

GetText exporting facility now can extract string members in array receiver of #translatedNoop,
while symbol members are ignored.

e.g.  aMenu addTranslatedList: 
		#( ( 'menu1'  ignored )  ('menu2' ignored 'balloon2') -) translatedNoop.



=== 1669playfieldOptions-sw.cs ===
Change Set:		playfieldOptions-sw
Date:			27 September 2007
Author:			Scott Wallace

Remove the 'viewing' halo handle, as per agreement on conference call on 26 Sept 07.
Spruce up the playfield-options menu by:
 - removing items that no longer make sense [e.g. about SqueakPages]
 - removing items that already occur elsewhere [e.g. open to drag and drop]
 - removing many items inappropriate for a World from the playfield options menu for a *world*
 - adding items formerly in the viewing-menu-halo-handle menu that were otherwise not available.
 - moving the one pen-trail-related item from the playfield-options to pen-trails menu.
Also fixed a refresh bug when toggling the 'indicate cursor' option.
Also fixed a bug in, and corrected the wording of, the menu items that show or hide viewers for all scripted players in a playfield.

=== 1668stringTransl-bf.cs ===
Change Set:		stringTransl-bf
Date:			26 September 2007
Author:			Bert Freudenberg

Make TextMorphs translateable. To try, simply switch a project's language, edit the text, and switch back.

=== 1667nonPlayerViewer-sw.cs ===
Change Set:		nonPlayerViewer-sw
Date:			14 September 2007
Author:			Scott Wallace

A few fixes to breathe a little life back into the 'Direct Viewer' -- i.e. a Viewer for a non-player object.

=== 1666simpleSwitchMorph-apb.cs ===
Change Set:		simpleSwitchMorph-apb
Date:			3 May 2006
Author:			Andrew P Black - Adapted 9/25/2007 for etoys/olpc use by sw,

Mantis bug 3530 -- see  http://bugs.squeak.org/print_bug_page.php?bug_id=3530

Provides compatibility support for examples in the book 'Squeak by Example' -- see http://www.iam.unibe.ch/~scg/SBE/

The only change from Andrew's SwitchMorphEnh.2.cs dated 5/3/06 is the removal of the SimpleSwitchMorphTest class, since SUnit is absent from the the squeakland and olpc end-user images.  We will in due course manage to get this into the olpc etoys development image, which *does* have SUnit in it.

=== 1665displayFix-bf.cs ===
Change Set:		displayFix-bf
Date:			21 September 2007
Author:			Bert Freudenberg

Release virtual display on shutdown, saving 4MB in the saved image.
